Scriptname FirstPersonAiming 
{Makes the game go into first person when using ADS}

GlobalVariable Property ThirdPersonADS_doubleClick Auto Mandatory
Holotape Property ThirdPersonADS_Holotape Auto Mandatory Const

Actor PlayerRef
bool clickedOnce = false
bool bQuickSwitch = false ;used to handle quick aiming and lag between states
float doubleClickTime = 0.3
Keyword ArmorTypePower

Event OnInit()
	PlayerRef = Game.GetPlayer()
	PlayerRef.AddItem(ThirdPersonADS_Holotape)
	RegisterForAnimEvents()
	game.ForceThirdPerson()
	RegisterForCameraState()
	GoToState("NADS")
	ArmorTypePower = Game.GetFormFromFile(0x0004D8A1, "Fallout4.esm") As Keyword
    	AddInventoryEventFilter(ArmorTypePower)
	RegisterForRemoteEvent(PlayerRef, "OnItemAdded")
   	RegisterForRemoteEvent(PlayerRef, "OnItemRemoved")
	;debug.notification("FPA init")
EndEvent

Function RegisterForAnimEvents()
	RegisterForAnimationEvent(PlayerRef, "sightedStateEnter")
	RegisterForAnimationEvent(PlayerRef, "sightedStateExit")
EndFunction

Event ObjectReference.OnItemAdded(ObjectReference akSender, Form akBaseItem, int aiItemCount, ObjectReference akItemReference, ObjectReference akSourceContainer)
EndEvent

Event ObjectReference.OnItemRemoved(ObjectReference akSender, Form akBaseItem, int aiItemCount, ObjectReference akItemReference, ObjectReference akDestContainer)
EndEvent

auto STATE NADS ;------------------------3rdPerson Not ADS State-----------------------------------------------
Event OnBeginState(string asOldState)
	if ( PlayerRef.WornHasKeyword(ArmorTypePower) || PlayerRef.IsInPowerArmor() )
		RegisterForAnimEvents()
	endif
	;debug.notification("In NADS")
EndEvent

Event OnAnimationEvent(ObjectReference akSource, string asEventName)
	;debug.notification(asEventName)
	if (asEventName == "sightedStateEnter" )
		if ;/( inFirstPerson  ) ;the player should be in FPS
			GoToState("FPS")
		elseif/; ( ThirdPersonADS_doubleClick.GetValue()==1 && !clickedOnce )
			clickedOnce = true
			StartTimer(doubleClickTime, 0)
		elseif  ( (ThirdPersonADS_doubleClick.GetValue()==1 && clickedOnce) || ThirdPersonADS_doubleClick.GetValue()==0 )
			game.ForceFirstPerson()
			bQuickSwitch = true
			StartTimer(0.3,2) ;timer cooldown once gone to ADS we can't go into FPS state
			GoToState("ADS")
		endif
	endif
EndEvent

;events needed because once a player enters or exit power armor, they unregister for ADS anim events
Event ObjectReference.OnItemAdded(ObjectReference akSender, Form akBaseItem, int aiItemCount, ObjectReference akItemReference, ObjectReference akSourceContainer)
    If PlayerRef.WornHasKeyword(ArmorTypePower)
		RegisterForAnimEvents()
    EndIf
EndEvent

Event ObjectReference.OnItemRemoved(ObjectReference akSender, Form akBaseItem, int aiItemCount, ObjectReference akItemReference, ObjectReference akDestContainer)    
	If !PlayerRef.WornHasKeyword(ArmorTypePower)
	 	RegisterForAnimEvents()
    	EndIf
EndEvent

; States
; 0 - First Person
; 1 - Auto Vanity
; 2 - VATS
; 3 - Free
; 4 - Iron Sights
; 5 - Transition
; 6 - Tween Menu
; 7 - ThirdPerson1
; 8 - ThirdPerson2
; 9 - Furniture
; 10 - Horse
; 11 - Bleedout
; 12 - Dialogue

Event OnPlayerCameraState(int oldState, int newState)
	;debug.notification("Cam state: " + newState)
	if (newState == 0) && (!bQuickSwitch)
		GoToState("FPS")
	elseif (newState == 9)
		RegisterForAnimEvents()
	endif
EndEvent

Event OnTimer(int aiTimerID)
	if aiTimerID == 0
		clickedOnce = false
	elseif aiTimerID == 2
		bQuickSwitch = false
	endif
EndEvent

endSTATE 

STATE ADS ;------------------3rdPerson ADS State--------------------------------------------------

Event OnBeginState(string asOldState)
	StartTimer(0.1,1) ;timer to check that player is still in iron sights
	;debug.notification("In ADS" )
EndEvent

Event OnAnimationEvent(ObjectReference akSource, string asEventName)
	;debug.messagebox(asEventName + PlayerRef.IsInIronSights())
	;debug.notification("Down Event from ADS " + asEventName)
	if (asEventName == "sightedStateExit" && !PlayerRef.IsInIronSights())
		game.ForceThirdPerson()
		GoToState("NADS")
	endif
EndEvent

Event OnTimer(int aiTimerID)
	if aiTimerID == 0
		clickedOnce = false
	elseif aiTimerID == 1
		if !PlayerRef.IsInIronSights()
			game.ForceThirdPerson()
			GoToState("NADS")
		endif
	elseif aiTimerID == 2
		bQuickSwitch = false
	endif
EndEvent

endSTATE 

STATE FPS ;------------------------------------First person already state -----------------------------
Event OnBeginState(string asOldState)
	;debug.notification("In FPS")
EndEvent

Event OnPlayerCameraState(int oldState, int newState)
	if newState == 8
		GoToState("NADS")
	endif
EndEvent

Event OnTimer(int aiTimerID)
	if aiTimerID == 0
		clickedOnce = false
	elseif aiTimerID == 2
		bQuickSwitch = false
	endif
EndEvent

endSTATE
